<?php
/**
 * Plugin Name: Bopo - WooCommerce Product Bundle Builder Premium
 * Plugin URI: https://www.persianscript.ir
 * Description: The effective way to create product bundle for WooCommerce
 * Version: 1.0.4
 * Author: persianscript.ir
 * Author URI: https://www.persianscript.ir
 * Text Domain: bopo-woocommerce-product-bundle-builder
 * Domain Path: /languages
 * Copyright 2022 VillaTheme.com. All rights reserved.
 * Requires at least: 5.0
 * Tested up to: 5.9
 * WC requires at least: 4.0
 * WC tested up to: 6.3
 * Requires PHP: 7.0
 */

defined( 'ABSPATH' ) || exit;
if ( ! defined( 'VI_WOO_BOPO_BUNDLE_VERSION' ) ) {
	define( 'VI_WOO_BOPO_BUNDLE_VERSION', '1.0.4' );
}
include_once( ABSPATH . 'wp-admin/includes/plugin.php' );
if ( is_plugin_active( 'woocommerce/woocommerce.php' ) ) {
	$init_file = WP_PLUGIN_DIR . DIRECTORY_SEPARATOR . "bopo-woocommerce-product-bundle-builder" . DIRECTORY_SEPARATOR . "includes" . DIRECTORY_SEPARATOR . "includes.php";
	require_once $init_file;
} else {
	if ( ! function_exists( 'wpc_notification' ) ) {
		function wpc_notification() {
			?>
            <div id="message" class="error">
                <p><?php esc_html_e( 'Please install and activate WooCommerce to use Bopo - WooCommerce Product Bundle Builder.', 'bopo-woocommerce-product-bundle-builder' ); ?></p>
            </div>
			<?php
		}
	}
	add_action( 'admin_notices', 'wpc_notification' );
}

if ( ! class_exists( 'VI_WOO_BOPO_BUNDLE' ) ) {
	class VI_WOO_BOPO_BUNDLE {

		public function __construct() {
			register_activation_hook( __FILE__, array( $this, 'install' ) );
			register_deactivation_hook( __FILE__, array( $this, 'uninstall' ) );
		}

		/**
		 * When active plugin Function will be call
		 */
		public function install() {
			global $wp_version;
			if ( version_compare( $wp_version, "5.1", "<" ) ) {
				deactivate_plugins( basename( __FILE__ ) ); // Deactivate our plugin
				wp_die( "This plugin requires WordPress version 5.1 or higher." );
			}
		}

		/**
		 * When deActive function will be call
		 */
		public function uninstall() {

		}
	}
}
new VI_WOO_BOPO_BUNDLE();